@ECHO OFF
ECHO Copy Random Files
ECHO Written By: Jason Faulkner
ECHO HowToGeek.com
ECHO.
ECHO.

REM This script randomly copies a specified number of files to the directory set below.

SETLOCAL EnableExtensions EnableDelayedExpansion

REM ------
REM Enter the folder where the files should be copied to.
REM Do not put the folder name in quotes.
REM If this folder does not exist, it will be created.
REM ------
SET Destination=


REM ------
REM Enter a file filter here. Separate entries with a semi-colon.
REM Leave this empty to list all files.
REM Examples --
REM List only PNG and JPG files: *.png;*.jpg
REM List only MP3, MWA and OGG files: *.mp3;*.wma;*.ogg
REM ------
SET FileFilter=


REM ------
REM If you want to pull files from sub-directories, enter /S here.
REM If you do not want to pull files from sub-directories, leave this empty.
REM ------
SET SubDirectories=/S


REM ---------------------------------------
REM Do not modify anything below this line.
REM ---------------------------------------

SET Source=%~dp1
SET FileList1Name=FileList1.%RANDOM%.txt
SET FileList1="%TEMP%\%FileList1Name%"
SET FileList2="%TEMP%\FileList2.%RANDOM%.txt"

ECHO Source: %Source%
IF /I {%SubDirectories%}=={/S} ECHO + Sub-Directories
IF NOT {"%FileFilter%"}=={""} ECHO File Filter: %FileFilter%
ECHO.
ECHO Destination: %Destination%
ECHO.
ECHO.
ECHO Building file list...

CD /D "%Source%"
DIR %FileFilter% /A:-D-H-S /B %SubDirectories% > %FileList1%

FOR /F "tokens=1,2,3 delims=:" %%A IN ('FIND /C ":" %FileList1%') DO SET TotalFiles=%%C
SET TotalFiles=%TotalFiles:~1%

ECHO The source has %TotalFiles% total files.
ECHO Enter the number of random files to copy to the destination.
SET /P FilesToCopy=
ECHO.

IF /I %TotalFiles% LSS %FilesToCopy% SET %FilesToCopy%=%TotalFiles%

SET Destination="%Destination%"
IF NOT EXIST %Destination% MKDIR %Destination%

SET ProgressTitle=Copying Random Files...

FOR /L %%A IN (1,1,%FilesToCopy%) DO (
	TITLE %ProgressTitle% %%A / %FilesToCopy%
	REM Pick a random file.
	SET /A RandomLine=!RANDOM! %% !TotalFiles!
	REM Go to the random file's line.
	SET Line=0
	FOR /F "usebackq tokens=*" %%F IN (%FileList1%) DO (
		IF !Line!==!RandomLine! (
			REM Found the line. Copy the file to the destination.
			XCOPY /V /Y "%%F" %Destination%
		) ELSE (
			REM Not the random file, build the new list without this file included.
			ECHO %%F>> %FileList2%
		)
		SET /A Line=!Line! + 1
	)
	SET /A TotalFiles=!TotalFiles! - 1
	REM Update the master file list with the new list without the last file.
	DEL /F /Q %FileList1%
	RENAME %FileList2% %FileList1Name%
)

IF EXIST %FileList1% DEL /F /Q %FileList1%
IF EXIST %FileList2% DEL /F /Q %FileList2%

ENDLOCAL